Redmine - Defect #42394

Inconsistent behaviour between attachment download routes with and without filename

2025-03-11 07:37 - Jens Kramer

Status: Closed Start date:

Priority: Normal Due date:

Assignee: Marius BALTEANU % Done: 0%
Category: Attachments Estimated time: 0.00 hour
Target version: 5.1.8

Resolution: Fixed Affected version:

Description

Currently, depending on the filename extension of the attachment (i.e., zip or txt), the named attachment download route sometimes
responds to unauthorized requests with a Status 401 instead of a redirect to the login form for unauthorized requests. This leads to
an error message about a broken link in the users' browser. The route without filename always correctly redirects to the login form.

The attached patch (courtesy of Planio) forces the format for the named attachment download route to HTML to fix that, so that the

routes with filename always redirects to “/login, as well.

Associated revisions

Revision 23581 - 2025-03-28 08:48 - Marius BALTEANU

Force format to html for the download_named_attachment route (#42394).

Patch by Jens Kramer (user:jkraemer).

Revision 23582 - 2025-03-29 14:05 - Marius BALTEANU
Update tests assertions after r23581 (#42394).

Revision 23583 - 2025-03-29 14:32 - Marius BALTEANU

Fixes rubocop offense "Style/HashSyntax: Don't mix styles in the same hash." (#42394).

Revision 23584 - 2025-03-29 14:48 - Marius BALTEANU
Merged r23581, r23582 and r23583 from trunk to 6.0-stable (#42394).

Revision 23585 - 2025-03-29 14:52 - Marius BALTEANU
Merged r23581, r23582 and r23583 from trunk to 5.1-stable (#42394).

History

#1 - 2025-03-17 19:03 - Marius BALTEANU

- Target version set to Candidate for next minor release

#2 - 2025-03-25 03:24 - Go MAEDA
- Tracker changed from Patch to Defect
- Status changed from New to Confirmed

- Target version changed from Candidate for next minor release to 5.1.8

#3 - 2025-03-28 08:51 - Marius BALTEANU

- Subject changed from inconsistent behaviour between attachment download routes with and without filename to Inconsistent behaviour between

attachment download routes with and without filename
- Status changed from Confirmed to Resolved
- Assignee set to Marius BALTEANU

- Resolution set to Fixed

#4 - 2025-03-29 07:25 - Go MAEDA

The commit r23581 broke two existing tests.
https://plan.io/redmine-hosting
https://www.redmine.org/projects/redmine/repository/svn/revisions/23581

Failure:
Redmine: :ApiTest::AttachmentsTest#test_GET_/attachments/download/:id/:filename_should_deny_access_without_cred
entials [test/integration/api_test/attachments_test.rb:66]:
Expected response to be a <401: unauthorized>, but was a <302: Found> redirect to <http://www.example.com/logi
n?back_url=http%$3A%2F%$2Fwww.example.com%2Fattachments%$2Fdownload%2F7%2Farchive.zip>
Response body:
Expected: 401
Actual: 302

bin/rails test test/integration/api_test/attachments_test.rb:64

Failure:

RoutingAttachmentsTest#test_attachments [test/test_helper.rb:330]:

The recognized options <{"format"=>"html", "controller"=>"attachments", "action"=>"download", "id"=>"1", "file
name"=>"filename.ext"}> did not match <{"id"=>"1", "filename"=>"filename.ext", "controller"=>"attachments", "a
ction"=>"download"}>, difference:.

—-—— expected
+++ actual
@@ -1 +1 @@

—{"id"=>"1", "filename"=>"filename.ext", "controller"=>"attachments", "action"=>"download"}
+{"format"=>"html", "controller"=>"attachments", "action"=>"download", "id"=>"1", "filename"=>"filename.ext"}

bin/rails test test/integration/routing/attachments_test.rb:23

#5 - 2025-03-30 09:23 - Marius BALTEANU

- Status changed from Resolved to Closed
